/* concat.c - concatenate a bunch of strings in managed memory */

#include "../h/mh.h"
#include <stdio.h>
#ifdef HAS_STDARG
#include <stdarg.h>
#else
#include <varargs.h>
#endif

/* VARARGS */

#ifdef HAS_STDARG
char   *concat (char *s1, ...)
#else
char   *concat (va_alist)
va_dcl
#endif
{
    register char  *cp,
                   *dp,
                   *sp;
    register unsigned   len;
    register    va_list list;

    len = 1;
#ifdef HAS_STDARG
    va_start (list, s1); 
    cp= s1;
#else
    va_start (list); 
    cp = va_arg (list, char *);
#endif
    while (cp)
    {
	len += strlen (cp);
	cp = va_arg (list, char *);
    }
    va_end (list);

    dp = sp = malloc (len);
    if (dp == NULL)
	adios (NULLCP, "unable to allocate string storage");

#ifdef HAS_STDARG
    va_start (list, s1); 
    cp= s1;
#else
    va_start (list); 
    cp = va_arg (list, char *);
#endif
    while (cp)
    {
	sp = copy (cp, sp);
	cp = va_arg (list, char *);
    }
    va_end (list);

    return dp;
}
